﻿using ff14bot.Interfaces;
using System;
using System.Threading;

namespace Reborn_Healer
{
    public class RebornInterface : IBotPlugin
    {
        #region - Variabbles

        private readonly Version _version = new Version(0, 1);
        internal Thread guiThread;

        public static RebornInterface Instance { get; private set; }

        string IBotPlugin.Author { get { return "Dragonslaya, Eterna"; } }

        #endregion - Variabbles

        #region - Public Plugin Information

        public string Author { get; private set; }

        public string Description { get; private set; }

        public Version Version { get { return new Version(0, 0, 1); } }

        #endregion - Public Plugin Information

        #region - IBotPlugin Interface Class Methods

        /// <summary>
        /// Unknown atm.
        /// </summary>
        /// <param name="other"></param>
        /// <returns></returns>
        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Unknown atm. IBotPlugin method.
        /// </summary>
        public void OnPulse()
        {
        }

        /// <summary>
        /// When plugin is initializing do stuff.
        /// </summary>
        public void OnInitialize()
        {
        }

        /// <summary>
        /// When the plugin is shutting down do stuff.
        /// </summary>
        public void OnShutdown()
        {
            //TODO: Finish.
            this.guiThread = null;
            frmMain.Instance.Close();
        }

        /// <summary>
        /// When user enables plugin do stuff.
        /// </summary>
        public void OnEnabled()
        {
            //TODO: Finish.
            this.Mainform();
        }

        /// <summary>
        /// When user disables plugin do stuff.
        /// </summary>
        public void OnDisabled()
        {
            //TODO: Finish.
        }

        /// <summary>
        /// Name of plugin.
        /// </summary>
        public string Name
        {
            get
            {
                return "Reborn Healer";
            }
        }

        /// <summary>
        /// Unknown atm.
        /// </summary>
        public bool WantButton
        {
            get { return true; }
        }

        /// <summary>
        /// Button text for plugin to click and run plugin.
        /// </summary>
        public string ButtonText
        {
            get { return "Run"; }
        }

        /// <summary>
        /// When you press button in the plugin interface of bot.
        /// </summary>
        public void OnButtonPress()
        {
            //TODO: Finish
            this.Mainform();
        }

        #endregion - IBotPlugin Interface Class Methods

        #region - Main Method

        public RebornInterface()
        {
            Instance = this;
        }

        #endregion - Main Method

        #region - Run Main Form

        public void Mainform()
        {
            if (guiThread == null || !guiThread.IsAlive)
            {
                guiThread = new Thread(() => new frmMain().ShowDialog())
                {
                    Name = "Main Gui Thread",
                    Priority = ThreadPriority.Normal,
                    IsBackground = true
                };
                guiThread.SetApartmentState(ApartmentState.STA);
                guiThread.Start();
            }
            else
            {
                if (frmMain.IsValid)
                    frmMain.Instance.Close();
                guiThread = null;
            }
        }

        #endregion - Run Main Form
    }
}