﻿namespace Reborn_Healer.Tasks.Combat.Modes
{
    public interface ICombatMode
    {
        /// <summary>
        /// Which mode the bot is currently running in.
        /// </summary>
        string BotMode { get; set; }

        /// <summary>
        /// Performs an update for the given combat mode.
        /// </summary>
        void PerformUpdate();
    }
}