﻿using Reborn_Healer.UI.Combat;
using System.Windows.Forms;

namespace Reborn_Healer
{
    public partial class frmProfileManager : Form
    {
        #region Variables
        private bool isOpen;
        #endregion

        #region Acessors
        public bool IsOpen { get { return isOpen; } }
        #endregion Acessors

        public frmProfileManager()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Loads up the UI for editing specific profile types of T.
        /// This is not bound to a particular type of profile.
        /// </summary>
        /// <typeparam name="T">The type of profile to load up and begin editing</typeparam>
        public void ShowAndBind<T>() where T : Profile.Profile
        {
            var control = new CombatProfileEditor();
            Controls.Add(control);

            ShowDialog();

            isOpen = false;
        }
    }
}